stages:
  - linter
  - build
  - push

Flake8:
  stage: linter
  image: python:3.6-alpine3.9
  script:
    - pip install flake8
    - flake8 --max-line-length=180
  
Build:
  stage: build
  image: docker:19
  services:
    - docker:dind
  script:
    - echo -n $CI_JOB_TOKEN | docker login -u gitlab-ci-token --password-stdin $CI_REGISTRY
    - docker pull $CI_REGISTRY_IMAGE:latest || true
    - >
      docker build
      --pull
      --cache-from $CI_REGISTRY_IMAGE:latest
      --tag $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA
      .
    - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA
   
Push:
  variables:
    GIT_STRATEGY: none
  stage: push
  image: docker:19
  services:
    - docker:dind
  script:
    - echo -n $CI_JOB_TOKEN | docker login -u gitlab-ci-token --password-stdin $CI_REGISTRY
    - docker pull $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA
    - > 
      if [ "$CI_COMMIT_REF_NAME" == "master" ]; then
        docker tag $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA $CI_REGISTRY_IMAGE:latest && 
        docker push $CI_REGISTRY_IMAGE:latest
      else
        docker tag $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME && 
        docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME
      fi
